/*
 * Cloudera Manager API
 * <h1>Cloudera Manager API v42</h1>       <p>Introduced in Cloudera Manager 7.1.4</p>       <p><a href=\"http://www.cloudera.com/documentation.html\">Cloudera Product Documentation</a></p>
 *
 * OpenAPI spec version: 7.1.4
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.cloudera.api.swagger;

import com.cloudera.api.swagger.client.ApiCallback;
import com.cloudera.api.swagger.client.ApiClient;
import com.cloudera.api.swagger.client.ApiException;
import com.cloudera.api.swagger.client.ApiResponse;
import com.cloudera.api.swagger.client.Configuration;
import com.cloudera.api.swagger.client.Pair;
import com.cloudera.api.swagger.client.ProgressRequestBody;
import com.cloudera.api.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import com.cloudera.api.swagger.model.ApiTagToEntitiesList;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TagsResourceApi {
    private ApiClient apiClient;

    public TagsResourceApi() {
        this(Configuration.getDefaultApiClient());
    }

    public TagsResourceApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getTags
     * @param limit Number of tags to search for. Maximum value for limit is 1000. (optional, default to 10)
     * @param offset Starting index of the list (optional, default to 0)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getTagsCall(Integer limit, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/tags";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getTagsValidateBeforeCall(Integer limit, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = getTagsCall(limit, offset, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Current CM entities and their tags.
     * Current CM entities and their tags. Tag names beginning with the prefix &lt;code&gt;_cldr_&lt;/code&gt; (case insensitive) are reserved for internal use by Cloudera.
     * @param limit Number of tags to search for. Maximum value for limit is 1000. (optional, default to 10)
     * @param offset Starting index of the list (optional, default to 0)
     * @return ApiTagToEntitiesList
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiTagToEntitiesList getTags(Integer limit, Integer offset) throws ApiException {
        ApiResponse<ApiTagToEntitiesList> resp = getTagsWithHttpInfo(limit, offset);
        return resp.getData();
    }

    /**
     * Current CM entities and their tags.
     * Current CM entities and their tags. Tag names beginning with the prefix &lt;code&gt;_cldr_&lt;/code&gt; (case insensitive) are reserved for internal use by Cloudera.
     * @param limit Number of tags to search for. Maximum value for limit is 1000. (optional, default to 10)
     * @param offset Starting index of the list (optional, default to 0)
     * @return ApiResponse&lt;ApiTagToEntitiesList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiTagToEntitiesList> getTagsWithHttpInfo(Integer limit, Integer offset) throws ApiException {
        com.squareup.okhttp.Call call = getTagsValidateBeforeCall(limit, offset, null, null);
        Type localVarReturnType = new TypeToken<ApiTagToEntitiesList>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Current CM entities and their tags. (asynchronously)
     * Current CM entities and their tags. Tag names beginning with the prefix &lt;code&gt;_cldr_&lt;/code&gt; (case insensitive) are reserved for internal use by Cloudera.
     * @param limit Number of tags to search for. Maximum value for limit is 1000. (optional, default to 10)
     * @param offset Starting index of the list (optional, default to 0)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getTagsAsync(Integer limit, Integer offset, final ApiCallback<ApiTagToEntitiesList> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getTagsValidateBeforeCall(limit, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiTagToEntitiesList>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for readTagsByName
     * @param tagName Name of the tag (required)
     * @param limit Number of entries to search for. Maximum value for limit is 1000. (optional, default to 10)
     * @param offset Starting index of the list (optional, default to 0)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call readTagsByNameCall(String tagName, Integer limit, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/tags/{tagName}"
            .replaceAll("\\{" + "tagName" + "\\}", apiClient.escapeString(tagName.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "basic" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call readTagsByNameValidateBeforeCall(String tagName, Integer limit, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'tagName' is set
        if (tagName == null) {
            throw new ApiException("Missing the required parameter 'tagName' when calling readTagsByName(Async)");
        }
        
        
        com.squareup.okhttp.Call call = readTagsByNameCall(tagName, limit, offset, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get Entities given the Tag name, grouped by entity type.
     * Get Entities given the Tag name, grouped by entity type.
     * @param tagName Name of the tag (required)
     * @param limit Number of entries to search for. Maximum value for limit is 1000. (optional, default to 10)
     * @param offset Starting index of the list (optional, default to 0)
     * @return ApiTagToEntitiesList
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiTagToEntitiesList readTagsByName(String tagName, Integer limit, Integer offset) throws ApiException {
        ApiResponse<ApiTagToEntitiesList> resp = readTagsByNameWithHttpInfo(tagName, limit, offset);
        return resp.getData();
    }

    /**
     * Get Entities given the Tag name, grouped by entity type.
     * Get Entities given the Tag name, grouped by entity type.
     * @param tagName Name of the tag (required)
     * @param limit Number of entries to search for. Maximum value for limit is 1000. (optional, default to 10)
     * @param offset Starting index of the list (optional, default to 0)
     * @return ApiResponse&lt;ApiTagToEntitiesList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ApiTagToEntitiesList> readTagsByNameWithHttpInfo(String tagName, Integer limit, Integer offset) throws ApiException {
        com.squareup.okhttp.Call call = readTagsByNameValidateBeforeCall(tagName, limit, offset, null, null);
        Type localVarReturnType = new TypeToken<ApiTagToEntitiesList>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get Entities given the Tag name, grouped by entity type. (asynchronously)
     * Get Entities given the Tag name, grouped by entity type.
     * @param tagName Name of the tag (required)
     * @param limit Number of entries to search for. Maximum value for limit is 1000. (optional, default to 10)
     * @param offset Starting index of the list (optional, default to 0)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call readTagsByNameAsync(String tagName, Integer limit, Integer offset, final ApiCallback<ApiTagToEntitiesList> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = readTagsByNameValidateBeforeCall(tagName, limit, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ApiTagToEntitiesList>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
